[BACK]Return to update_openbsd CVS log [TXT][DIR] Up to [local] / openbsd / update_openbsd

Diff for /openbsd/update_openbsd/update_openbsd between version 1.98 and 1.116

version 1.98, 2017/12/11 01:35:44 version 1.116, 2018/12/16 20:55:24
Line 1 
Line 1 
 #!/bin/sh  #!/bin/sh
 # $AFresh1: update_openbsd,v 1.97 2017/12/11 00:52:41 andrew Exp $  # $AFresh1: update_openbsd,v 1.115 2018/12/16 20:55:03 andrew Exp $
 #  #
 # Copyright (c) 2012 Andrew Fresh <andrew@afresh1.com>  # Copyright (c) 2012 Andrew Fresh <andrew@afresh1.com>
 #  #
Line 52 
Line 52 
     #what $1 | sed -ne 's/[[:blank:]]\{1,\}//p'      #what $1 | sed -ne 's/[[:blank:]]\{1,\}//p'
 }  }
   
   kernel_is_multiprocessor() {
       printf "find cpu*\nexit\n" | config -e $1 2>/dev/null | grep -q "cpu\* at "
   }
   
 version_in() {  version_in() {
         local _proto=${FTP%%://*}          local _proto=${FTP%%://*}
         local _file          local _file
Line 80 
Line 84 
 }  }
   
 set_boot_device() {  set_boot_device() {
         BOOT_DEVICE=$( df -nP /bsd | sed -ne 's! .*/$!!p' )          BOOT_DEVICE=$( df -lnP /bsd | sed -ne 's! .*/$!!p' )
   
         root_disk=$( echo $BOOT_DEVICE |          root_disk=$( echo $BOOT_DEVICE |
             sed -e 's,/dev/\([a-z]*[0-9]\)[a-z].*,\1,' )              sed -e 's,/dev/\([a-z]*[0-9]\)[a-z].*,\1,' )
Line 94 
Line 98 
             BOOT_DEVICE="/dev/$root_disk$msdos_partition"              BOOT_DEVICE="/dev/$root_disk$msdos_partition"
 }  }
   
   boot_device_mounted=""
   mount_boot_device() {
       [ "$boot_device_mounted" ] && return
       [ "$BOOT_DEVICE" ] || return
   
       local boot_mount=$( mount |
               sed -ne "s!^$BOOT_DEVICE on \([^ ]*\).*!\1!p" )
   
       if [ ! "$boot_mount" ]; then
           mount $BOOT_DEVICE /mnt
           boot_device_mounted=1
       fi
   }
   
   umount_boot_device() {
       [ "$boot_device_mounted" ] && umount $BOOT_DEVICE
       boot_device_mounted=""
   }
   
   find_boot_kernel() {
       local _k=$( ( \
           echo bsd; \
           [ -e boot.conf ] && sed -E '/^ *(set +image|boot) +/!d ; \
               s///; s/^.*://; s/ .*$//' boot.conf \
       ) | tail -1 )
       _k=$( follow_symlink $_k )
   
       local _d=$( dirname $_k )
       [ "$_d" = "." ] && _d=$PWD
   
       if [ $_d = . -o $_d = $PWD ]; then
           basename $_k
       else
           echo $_k
       fi
   }
   
 set_version() {  set_version() {
     CUR_VER=`uname -r`      CUR_VER=`uname -r`
     NEW_VER=`dc -e "$CUR_VER 0.1 + p"`      NEW_VER=`dc -e "$CUR_VER 0.1 + p"`
Line 102 
Line 143 
   
     local _cv=`echo $CUR_VER | sed -e 's/\.//'`      local _cv=`echo $CUR_VER | sed -e 's/\.//'`
     local _nv=`echo $NEW_VER | sed -e 's/\.//'`      local _nv=`echo $NEW_VER | sed -e 's/\.//'`
     local _v      local _v _d _pkr
   
     if [ X"No" != X"$FORCE_DIR" -a -d $FORCE_DIR ]; then      if [ X"No" != X"$FORCE_DIR" -a -d $FORCE_DIR ]; then
         _dir=$FORCE_DIR          _dir=$FORCE_DIR
Line 190 
Line 231 
         FTP=${MIRROR}/${_dir}/`machine`          FTP=${MIRROR}/${_dir}/`machine`
     fi      fi
   
     BOOT_KERNEL=`( \      KERNEL_ROOT=""
         echo bsd; \      [ -z "$BOOT_DEVICE" ] && set_boot_device
         [ -e /boot.conf ] && sed -E '/^ *(set +image|boot) +/!d ; \  
             s///; s/^.*://; s/ .*$//' /boot.conf \  
     ) | tail -1`  
     BOOT_KERNEL=`follow_symlink /$BOOT_KERNEL`  
     BOOT_KERNEL="/${BOOT_KERNEL#/}"  
   
     BOOT_KERNEL_VERSION=`kernel_file_version $BOOT_KERNEL`      mount_boot_device
   
       # _pkr == possible_kernel_roots
       _pkr=/
       [ "$BOOT_DEVICE" ] && _pkr="/mnt/ $_pkr"
   
       for _d in $_pkr; do
           KERNEL_ROOT=$( df -lnP ${_d}bsd 2>/dev/null | sed -ne 's!/dev/.* !!p' )
           [ "$KERNEL_ROOT" ] && break
       done
   
       if ! [ "$KERNEL_ROOT" ]; then
           echo "Unable to find KERNEL_ROOT, tried $_pkr" >&2
           exit 2
       fi
   
       cd $KERNEL_ROOT
       BOOT_KERNEL=$( find_boot_kernel )
       BOOT_KERNEL_VERSION=$( kernel_file_version $BOOT_KERNEL )
       if [ $(sysctl -n hw.ncpufound) -gt 1 ] || kernel_is_multiprocessor $BOOT_KERNEL; then
           BOOT_KERNEL=bsd.mp
       fi
   
     BOOTED_KERNEL_VERSION=`sysctl -n kern.version`      BOOTED_KERNEL_VERSION=`sysctl -n kern.version`
     NEW_KERNEL_VERSION=""      NEW_KERNEL_VERSION=""
   
     # We want to default to what we had      # We want to default to what we had
     INSTALL_KERNELS="${BOOT_KERNEL#/}"      INSTALL_KERNELS="$BOOT_KERNEL"
     # if the boot kernel was our specially named bsd.sp, we install from bsd      # if the boot kernel was our specially named bsd.sp, we install from bsd
     if [ X"$INSTALL_KERNELS" == X"bsd.sp" ]; then      if [ X"$INSTALL_KERNELS" == X"bsd.sp" ]; then
         INSTALL_KERNELS="bsd"          INSTALL_KERNELS="bsd"
     fi      fi
     # with a second option of an mp kernel if is is a likely candidate  
     if [ X"$INSTALL_KERNELS" != X"bsd.mp" ]; then      # We want to update all kernels that exist
         local _ncpu=$(sysctl -n hw.ncpufound)      # either in the $KERNEL_ROOT or in /
         [ $_ncpu -gt 1 ] && INSTALL_KERNELS="$INSTALL_KERNELS bsd.mp"      for b in bsd bsd.mp; do
           [ -e $b -o -e /$b ] || continue
           if [ X"${INSTALL_KERNELS% *}" != X"$b" ]; then
               INSTALL_KERNELS="$INSTALL_KERNELS $b"
           fi
       done
   
       cd $OLDPWD
   
       EFI_BOOT=""
       if [ -d "/mnt/efi/boot" ]; then
           _d=$( cd "/mnt/efi/boot" && ls -1 *.{efi,EFI} 2>/dev/null )
           # assume an MSDOS filesystem and so case insensitive
           [ "$_d" ] && EFI_BOOT=$( echo $_d | tr a-z A-Z )
     fi      fi
     # or just bsd otherwise  
     if [ X"${INSTALL_KERNELS% *}" != X"bsd" ]; then      umount_boot_device
         INSTALL_KERNELS="$INSTALL_KERNELS bsd"  
     fi  
     BOOT_KERNELS=$INSTALL_KERNELS      BOOT_KERNELS=$INSTALL_KERNELS
     INSTALL_KERNELS="$INSTALL_KERNELS bsd.rd"      INSTALL_KERNELS="$INSTALL_KERNELS bsd.rd"
 }  }
Line 234 
Line 303 
   
     local _v=$FILE_VER      local _v=$FILE_VER
   
       if [ "$EFI_BOOT" ]; then
           _b="$EFI_BOOT"
           if [ ! -e ./${_b} ]; then
               echo "===> $FTP_CMD ${FTP}/${_b}"
               $FTP_CMD ${FTP}/${_b}
           else
               echo "===> Have ${_b}"
           fi
       fi
   
     for _b in $INSTALL_KERNELS; do      for _b in $INSTALL_KERNELS; do
         if [ ! -e ./${_b} ]; then          if [ ! -e ./${_b} ]; then
             echo "===> $FTP_CMD ${FTP}/${_b}"              echo "===> $FTP_CMD ${FTP}/${_b}"
Line 322 
Line 401 
     local _missing_sets      local _missing_sets
     local _v=$FILE_VER      local _v=$FILE_VER
   
       mount_boot_device
     for _n in $INSTALL_KERNELS; do      for _n in $INSTALL_KERNELS; do
         local _o=$_n          local _o=$_n
         [ X"bsd" == X"${_o}" -a -e /bsd.sp ] && _o=bsd.sp          [ X"bsd" == X"${_o}" -a -e ${KERNEL_ROOT}bsd.sp ] && _o=bsd.sp
         if [ -e /${_o} -a ! -e ./${_n} ]; then          if [ -e ${KERNEL_ROOT}${_o} -a ! -e ./${_n} ]; then
             echo ${_o} does not exist              echo ${_o} does not exist on $BOOT_DEVICE
             _missing_sets=1              _missing_sets=1
         fi          fi
   
         if [ X"${BOOT_KERNEL}" == X"/${_o}" -a -e ./${_n} ]; then          if [ X"${BOOT_KERNEL}" == X"${_o}" -a -e ./${_n} ]; then
             NEW_KERNEL_VERSION=`kernel_file_version ./${_n}`              NEW_KERNEL_VERSION=`kernel_file_version ./${_n}`
         fi          fi
     done      done
       umount_boot_device
   
     if [ X"$NEW_KERNEL_VERSION" == X"" ]; then      if [ X"$NEW_KERNEL_VERSION" == X"" ]; then
         echo Missing replacement for boot kernel $BOOT_KERNEL >&2          echo Missing replacement for boot kernel $BOOT_KERNEL >&2
Line 370 
Line 451 
   
   
 install_kernels() {  install_kernels() {
     local _d=$1      local _d="$1"
     local default_mount=$( df -lnP /bsd | sed -ne 's!/dev/.* !!p' )  
     local boot_mount      local boot_mount
     local mount_is_msdos      local mount_is_msdos
   
     if [ ! "$_d" ]; then      if [ "$_d" ]; then
         boot_mount=$( mount |        _d=$( readlink -nf "$_d" )
             sed -ne "s!^$BOOT_DEVICE on \([^ ]*\).*!\1!p" )      else
           mount_boot_device
   
         local _ik="$INSTALL_KERNELS"          if [ "$KERNEL_ROOT" != "/" ]; then
         INSTALL_KERNELS="${BOOT_KERNEL#/} bsd.rd"                  local _ik="$INSTALL_KERNELS"
                   INSTALL_KERNELS="$BOOT_KERNEL bsd.rd"
   
         if [ ! "$boot_mount" ]; then                  install_kernels $KERNEL_ROOT
                 mount $BOOT_DEVICE /mnt  
                 install_kernels /mnt/                  INSTALL_KERNELS="$_ik"
                 umount $BOOT_DEVICE  
         elif [ "$boot_mount" != "$default_mount" ]; then  
                 install_kernels $boot_mount/  
         fi          fi
   
         INSTALL_KERNELS="$_ik"          umount_boot_device
         install_kernels $default_mount  
           install_kernels /
         return          return
     fi      fi
   
Line 402 
Line 482 
         exit 1          exit 1
     fi      fi
   
     mount | grep -q " ${_d%/} .* msdos" && mount_is_msdos=1      [ $_d != / ] && _d=${_d%/}/
       [ $_d != / ] && mount | grep -q " on ${_d%/} .* msdos" && mount_is_msdos=1
   
       if [ "$EFI_BOOT" -a -d /mnt/efi/boot ]; then
          echo "Copying $EFI_BOOT to /mnt/efi/boot/$EFI_BOOT"
          ( cd /mnt/efi/boot \
            && cp "$RELEASEDIR/$EFI_BOOT" "n$EFI_BOOT" \
            && mv "n$EFI_BOOT" "$EFI_BOOT"
          )
       fi
   
     if [ X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then      if [ X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
         echo "===> Backing up $BOOT_KERNEL to ${_d}obsd"          echo "===> Backing up ${_d}$BOOT_KERNEL to ${_d}obsd"
         if [ $mount_is_msdos ]; then          if [ $mount_is_msdos ]; then
             cp $BOOT_KERNEL ${_d}obsd              cp ${_d}$BOOT_KERNEL ${_d}obsd
         else          else
             ln -f $BOOT_KERNEL ${_d}obsd              ln -f ${_d}$BOOT_KERNEL ${_d}obsd
         fi          fi
         if [ $? -ne 0 ]; then          if [ $? -ne 0 ]; then
             echo "Error copying old kernel!" >&2              echo "Error copying old kernel!" >&2
Line 557 
Line 646 
     . ${HOME}/.update_openbsdrc      . ${HOME}/.update_openbsdrc
 fi  fi
   
 MIRROR=${MIRROR:=http://fastly.cdn.openbsd.org/pub/OpenBSD}  MIRROR=${MIRROR:=http://cdn.openbsd.org/pub/OpenBSD}
 FTP_CMD=${FTP_CMD:=ftp -V}  FTP_CMD=${FTP_CMD:=ftp -V}
   
 DESTDIR=${DESTDIR:=/}  DESTDIR=${DESTDIR:=/}
Line 567 
Line 656 
 export PKG_PATH TRUSTED_PKG_PATH  export PKG_PATH TRUSTED_PKG_PATH
   
 set_version  set_version
 [ -z "$BOOT_DEVICE" ] && set_boot_device  
   
 TRUSTED_PKG_PATH=${TRUSTED_PKG_PATH:=/usr/ports/packages/`machine -a`/all}  TRUSTED_PKG_PATH=${TRUSTED_PKG_PATH:=/usr/ports/packages/`machine -a`/all}
 if [ "$FORCE_DIR" = "No" ]; then  if [ "$FORCE_DIR" = "No" ]; then
Line 593 
Line 681 
 echo "      RELEASEDIR: $RELEASEDIR"  echo "      RELEASEDIR: $RELEASEDIR"
 echo "         DESTDIR: $DESTDIR"  echo "         DESTDIR: $DESTDIR"
 echo "     BOOT_DEVICE: $BOOT_DEVICE"  echo "     BOOT_DEVICE: $BOOT_DEVICE"
   [ "$EFI_BOOT" ] && echo "        EFI_BOOT: $EFI_BOOT"
 echo "     BOOT_KERNEL: $BOOT_KERNEL"  echo "     BOOT_KERNEL: $BOOT_KERNEL"
 echo " INSTALL_KERNELS: $INSTALL_KERNELS"  echo " INSTALL_KERNELS: $INSTALL_KERNELS"
 echo "  INSTALLED_SETS: $INSTALLED_SETS"  echo "  INSTALLED_SETS: $INSTALLED_SETS"
Line 602 
Line 691 
 #echo "        FILE_VER: $FILE_VER"  #echo "        FILE_VER: $FILE_VER"
 echo  echo
   
   mount_boot_device
   l=$KERNEL_ROOT
   [ "$l" = / ] || l="$BOOT_DEVICE:"
 for k in $INSTALL_KERNELS; do  for k in $INSTALL_KERNELS; do
     if [ -e "/$k" ]; then      if [ -e $KERNEL_ROOT$k ]; then
         echo "Existing $k"          echo "Existing $l$k"
         kernel_file_version "/$k"          kernel_file_version $KERNEL_ROOT$k
     fi      fi
 done  done
   umount_boot_device
   
 if [ ${_error} -ne 0 ]; then  if [ ${_error} -ne 0 ]; then
         exit ${_error}          exit ${_error}

Legend:
Removed from v.1.98  
changed lines
  Added in v.1.116

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>